/*
	DTMF  (c) 1993 Peter Jennings      peterj@netcom.com

	DTMF includes source code developed by:

	FFT copyright (c) 1992 Franois Jalbert (jalbert@IRO.UMontreal.CA)
	Sound-Blaster C Library BLAST13 (c) 1991 Joel Lucsy
		DIRECT.OBJ and direct.h are part of BLAST13 which is obtainable
		from SimTel and other sites. Simtel: pub/msdos/sound/blast13.zip
	DTMF code (c) 1993 Peter Jennings

    Turbo-C flags used: -mt -1 -d -f- -A -K -G -O -w

1.01   Removed the speaker_off() function calls that tripped up SBPro
	   Didn't help!

*/

#include <direct.h> /* BLAST13 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <time.h>

#define TRUE  1
#define FALSE 0
#define N 16 /* number of FFT terms, do not change this!!! See also LOG2N */

#define THRESHOLD 8 /* DTMF minimum signal */

static unsigned int videoseg=0xB800; /* assume color */
char buffer[1024],file[32];
int bptr=0;
FILE *fptr;

/*----------------------------------- FFT ------------------------------------*/

#define S0  0 /* corresponds to 0.0 */
#define S1  3
#define S2  6
#define S3  9 /* sin() table with 4 bit precision */
#define S4 11 /* increasing precision will cause short integer overflows... */
#define S5 13 /* too bad, I really would have liked more precision */
#define S6 15
#define S7 16
#define S8 16 /* corresponds to 1.0 */
#define SCALE 11 /* scale FFT with 2**SCALE from big values to low */

static int FFTenable=FALSE; /* Maximum sampling rate for initial SW tuning */
static int waitfactor=3; /* Best initial sampling rate for my 12MHz 286 */
static int fft[N],oldfft[N];
static int col[3],row[4];

void FFT(void)
{ /* compute fast short integer FT */
  static int k,l,f[N+N];
  static int f16p0,f17m1,f17p1,f18m2,f18p2,f19m3,f19p3;
  static int f20m4,f20p4,f21m5,f21p5,f22m6,f22p6,f23m7,f23p7;
  static int f24p8,f25m9,f25p9,f26m10,f26p10,f27m11,f27p11;
  static int f28m12,f28p12,f29m13,f29p13,f30m14,f30p14,f31m15,f31p15;
  static int f25m9Mf23m7,f25m9Pf23m7,f26m10Mf22m6,f26m10Pf22m6;
  static int f27m11Pf21m5,f29m13Mf19m3,f29m13Pf19m3,f27m11Mf21m5;
  static int f30m14Mf18m2,f30m14Pf18m2,f31m15Mf17m1,f31m15Pf17m1;
  static int f24p8Pf16p0,f25p9Mf23p7,f25p9Pf23p7,f26p10Mf22p6,f26p10Pf22p6;
  static int f27p11Mf21p5,f27p11Pf21p5,f28p12Pf20p4,f29p13Mf19p3;
  static int f29p13Pf19p3,f30p14Mf18p2,f30p14Pf18p2,f31p15Mf17p1,f31p15Pf17p1;
  static int f29Mf19Pf27Mf21,f29Pf19Mf27Pf21,f29Mf19Mf27Mf21;
  static int f31Mf17Pf25Mf23,f31Pf17Mf25Pf23,f31Mf17Mf25Mf23;
  static int s4Mf28f20,s4Pf28f20;
  static int s4Mf30f18f26f22,s4Pf30f26f22f18,s4Mf31f29f27f25,s4Pf31f29f27f25;
  static int s8Mf30f18f26f22,s8Pf28f24f20f16,s8Mf24f16,s8Mf28f20,s8f16,s8f24;
  static int s4Mf30f26Ms8Mf28,s4Mf30f26Ps8Mf28;
  static int s4Pf30f22Ms8Mf24,s4Pf30f22Ps8Mf24;
  static int s6Mf31f25Ms2Mf29f27,s6Mf29f27Ps2Mf31f25;
  static int s6Pf29f27Ms2Pf31f25,s6Pf31f25Ps2Pf29f27;
  static int s1Mf25s3f27s5f29s7f31,s1Pf25s3f27s5f29s7f31;
  static int s1Mf27s3f31s5f25s7f29,s1Pf27s3f31s5f25s7f29;
  static int s1Mf29s3f25s5f31s7f27,s1Pf29s3f25s5f31s7f27;
  static int s1Mf31s3f29s5f27s7f25,s1Pf31s3f29s5f27s7f25;
  static int s2Mf26Ps6Mf30,s2Pf26Ms6Pf30,s2Mf30Ms6Mf26,s2Pf30Ps6Pf26;
  static int s4Mf28Ps8f16,s4Mf28Ms8f16,s4Pf28Ps8f24,s4Pf28Ms8f24;
  static int s2Mf26Ps4f28s6f30Ms8f16,s2Mf26Ms4f28s6f30Ps8f16;
  static int s2Pf26Ms4f28s6f30Ps8f24,s2Pf26Ps4f28s6f30Ms8f24;
  static int s2Mf30Ps4f28s6f26Ps8f16,s2Mf30Ms4f28s6f26Ms8f16;
  static int s2Pf30Ps4f28s6f26Ps8f24,s2Pf30Ms4f28s6f26Ms8f24;

  for (k=0 ; k<(N+N) ; k++) {
    for (l=1 ; l<waitfactor ; l++) read_data();
    f[k]=read_data()-128;
  }
  f17m1 =f[17]-f[1];  f17p1 =f[17]+f[1];
  f18m2 =f[18]-f[2];  f18p2 =f[18]+f[2];
  f19m3 =f[19]-f[3];  f19p3 =f[19]+f[3];
  f20m4 =f[20]-f[4];  f20p4 =f[20]+f[4];
  f21m5 =f[21]-f[5];  f21p5 =f[21]+f[5];
  f22m6 =f[22]-f[6];  f22p6 =f[22]+f[6];
  f23m7 =f[23]-f[7];  f23p7 =f[23]+f[7];
  f16p0 =f[16]+f[0];  f24p8 =f[24]+f[8];
  f25m9 =f[25]-f[9];  f25p9 =f[25]+f[9];
  f26m10=f[26]-f[10]; f26p10=f[26]+f[10];
  f27m11=f[27]-f[11]; f27p11=f[27]+f[11];
  f28m12=f[28]-f[12]; f28p12=f[28]+f[12];
  f29m13=f[29]-f[13]; f29p13=f[29]+f[13];
  f30m14=f[30]-f[14]; f30p14=f[30]+f[14];
  f31m15=f[31]-f[15]; f31p15=f[31]+f[15];
  f25m9Mf23m7 =f25m9 -f23m7; f25m9Pf23m7 =f25m9 +f23m7;
  f26m10Mf22m6=f26m10-f22m6; f26m10Pf22m6=f26m10+f22m6;
  f27m11Mf21m5=f27m11-f21m5; f27m11Pf21m5=f27m11+f21m5;
  f29m13Mf19m3=f29m13-f19m3; f29m13Pf19m3=f29m13+f19m3;
  f30m14Mf18m2=f30m14-f18m2; f30m14Pf18m2=f30m14+f18m2;
  f31m15Mf17m1=f31m15-f17m1; f31m15Pf17m1=f31m15+f17m1;
  f25p9Mf23p7 =f25p9 -f23p7; f25p9Pf23p7 =f25p9 +f23p7;
  f26p10Mf22p6=f26p10-f22p6; f26p10Pf22p6=f26p10+f22p6;
  f27p11Mf21p5=f27p11-f21p5; f27p11Pf21p5=f27p11+f21p5;
  f24p8Pf16p0 =f24p8 +f16p0; f28p12Pf20p4=f28p12+f20p4;
  f29p13Mf19p3=f29p13-f19p3; f29p13Pf19p3=f29p13+f19p3;
  f30p14Mf18p2=f30p14-f18p2; f30p14Pf18p2=f30p14+f18p2;
  f31p15Mf17p1=f31p15-f17p1; f31p15Pf17p1=f31p15+f17p1;
  f29Mf19Pf27Mf21=f29p13Mf19p3+f27p11Mf21p5;
  f29Pf19Mf27Pf21=f29p13Pf19p3-f27p11Pf21p5;
  f29Mf19Mf27Mf21=f29p13Mf19p3-f27p11Mf21p5;
  f31Mf17Pf25Mf23=f31p15Mf17p1+f25p9Mf23p7;
  f31Pf17Mf25Pf23=f31p15Pf17p1-f25p9Pf23p7;
  f31Mf17Mf25Mf23=f31p15Mf17p1-f25p9Mf23p7;
  s4Mf30f18f26f22=S4*(f30p14Mf18p2+f26p10Mf22p6);
  s4Pf30f26f22f18=S4*(f30p14Pf18p2-f26p10Pf22p6);
  s4Mf31f29f27f25=S4*(f31Mf17Mf25Mf23+f29Mf19Mf27Mf21);
  s4Pf31f29f27f25=S4*(f31p15Pf17p1+f25p9Pf23p7-f29p13Pf19p3-f27p11Pf21p5);
  s8Mf30f18f26f22=S8*(f30p14Mf18p2-f26p10Mf22p6);
  s8Pf28f24f20f16=S8*(f28p12Pf20p4-f24p8Pf16p0);
  s8Mf24f16=S8*(f24p8-f16p0);
  s8Mf28f20=S8*(f28p12-f20p4);
  s4Mf30f26Ms8Mf28=s4Mf30f18f26f22-s8Mf28f20;
  s4Mf30f26Ps8Mf28=s4Mf30f18f26f22+s8Mf28f20;
  s4Pf30f22Ms8Mf24=s4Pf30f26f22f18-s8Mf24f16;
  s4Pf30f22Ps8Mf24=s4Pf30f26f22f18+s8Mf24f16;
  s6Mf31f25Ms2Mf29f27=S6*f31Mf17Pf25Mf23-S2*f29Mf19Pf27Mf21;
  s6Mf29f27Ps2Mf31f25=S6*f29Mf19Pf27Mf21+S2*f31Mf17Pf25Mf23;
  s6Pf29f27Ms2Pf31f25=S6*f29Pf19Mf27Pf21-S2*f31Pf17Mf25Pf23;
  s6Pf31f25Ps2Pf29f27=S6*f31Pf17Mf25Pf23+S2*f29Pf19Mf27Pf21;
  s1Mf25s3f27s5f29s7f31=S1*f25m9Mf23m7+S3*f27m11Mf21m5+S5*f29m13Mf19m3+S7*f31m15Mf17m1;
  s1Pf25s3f27s5f29s7f31=S1*f25m9Pf23m7-S3*f27m11Pf21m5+S5*f29m13Pf19m3-S7*f31m15Pf17m1;
  s1Mf27s3f31s5f25s7f29=S1*f27m11Mf21m5+S3*f31m15Mf17m1+S5*f25m9Mf23m7-S7*f29m13Mf19m3;
  s1Pf27s3f31s5f25s7f29=S1*f27m11Pf21m5+S3*f31m15Pf17m1-S5*f25m9Pf23m7+S7*f29m13Pf19m3;
  s1Mf29s3f25s5f31s7f27=S1*f29m13Mf19m3+S3*f25m9Mf23m7-S5*f31m15Mf17m1+S7*f27m11Mf21m5;
  s1Pf29s3f25s5f31s7f27=S1*f29m13Pf19m3+S3*f25m9Pf23m7+S5*f31m15Pf17m1-S7*f27m11Pf21m5;
  s1Mf31s3f29s5f27s7f25=S1*f31m15Mf17m1-S3*f29m13Mf19m3+S5*f27m11Mf21m5-S7*f25m9Mf23m7;
  s1Pf31s3f29s5f27s7f25=S1*f31m15Pf17m1+S3*f29m13Pf19m3+S5*f27m11Pf21m5+S7*f25m9Pf23m7;
  s2Mf26Ps6Mf30=S2*f26m10Mf22m6+S6*f30m14Mf18m2;;
  s2Pf26Ms6Pf30=S2*f26m10Pf22m6-S6*f30m14Pf18m2;
  s2Mf30Ms6Mf26=S2*f30m14Mf18m2-S6*f26m10Mf22m6;
  s2Pf30Ps6Pf26=S2*f30m14Pf18m2+S6*f26m10Pf22m6;
  s4Mf28f20=S4*(f28m12-f20m4); s4Pf28f20=S4*(f28m12+f20m4);
  s8f16=S8*(f[16]-f[0]); s8f24=S8*(f[24]-f[8]);
  s4Mf28Ps8f16=s4Mf28f20+s8f16;
  s4Mf28Ms8f16=s4Mf28f20-s8f16;
  s4Pf28Ps8f24=s4Pf28f20+s8f24;
  s4Pf28Ms8f24=s4Pf28f20-s8f24;
  s2Mf26Ps4f28s6f30Ms8f16=s2Mf26Ps6Mf30+s4Mf28Ms8f16;
  s2Mf26Ms4f28s6f30Ps8f16=s2Mf26Ps6Mf30-s4Mf28Ms8f16;
  s2Pf26Ms4f28s6f30Ps8f24=s2Pf26Ms6Pf30-s4Pf28Ms8f24;
  s2Pf26Ps4f28s6f30Ms8f24=s2Pf26Ms6Pf30+s4Pf28Ms8f24;
  s2Mf30Ps4f28s6f26Ps8f16=s2Mf30Ms6Mf26+s4Mf28Ps8f16;
  s2Mf30Ms4f28s6f26Ms8f16=s2Mf30Ms6Mf26-s4Mf28Ps8f16;
  s2Pf30Ps4f28s6f26Ps8f24=s2Pf30Ps6Pf26+s4Pf28Ps8f24;
  s2Pf30Ms4f28s6f26Ms8f24=s2Pf30Ps6Pf26-s4Pf28Ps8f24;
  fft[1]=(abs(s1Mf25s3f27s5f29s7f31+s2Mf26Ps4f28s6f30Ms8f16)>>SCALE)+
         (abs(s1Pf31s3f29s5f27s7f25+s2Pf30Ps4f28s6f26Ps8f24)>>SCALE);
  fft[2]=(abs(s6Pf31f25Ps2Pf29f27+s4Pf30f22Ms8Mf24)>>SCALE)+
         (abs(s6Mf29f27Ps2Mf31f25+s4Mf30f26Ps8Mf28)>>SCALE);
  fft[3]=(abs(s2Mf30Ms4f28s6f26Ms8f16-s1Mf29s3f25s5f31s7f27)>>SCALE)+
         (abs(s2Pf26Ms4f28s6f30Ps8f24-s1Pf27s3f31s5f25s7f29)>>SCALE);
  fft[4]=(abs(s4Pf31f29f27f25-s8Pf28f24f20f16)>>SCALE)+
         (abs(s4Mf31f29f27f25+s8Mf30f18f26f22)>>SCALE);
  fft[5]=(abs(s1Mf27s3f31s5f25s7f29-s2Mf30Ps4f28s6f26Ps8f16)>>SCALE)+
         (abs(s2Pf26Ps4f28s6f30Ms8f24-s1Pf29s3f25s5f31s7f27)>>SCALE);
  fft[6]=(abs(s6Pf29f27Ms2Pf31f25+s4Pf30f22Ps8Mf24)>>SCALE)+
         (abs(s6Mf31f25Ms2Mf29f27+s4Mf30f26Ms8Mf28)>>SCALE);
  fft[7]=(abs(s1Mf31s3f29s5f27s7f25-s2Mf26Ms4f28s6f30Ps8f16)>>SCALE)+
         (abs(s1Pf25s3f27s5f29s7f31-s2Pf30Ms4f28s6f26Ms8f24)>>SCALE);
  fft[8]=(abs(S8*(f30p14Pf18p2+f26p10Pf22p6-f28p12Pf20p4-f24p8Pf16p0))>>SCALE)+
         (abs(S8*(f31Mf17Mf25Mf23-f29Mf19Mf27Mf21))>>SCALE);
  fft[9]=(abs(s1Mf31s3f29s5f27s7f25+s2Mf26Ms4f28s6f30Ps8f16)>>SCALE)+
         (abs(s1Pf25s3f27s5f29s7f31+s2Pf30Ms4f28s6f26Ms8f24)>>SCALE);
  fft[10]=(abs(s6Pf29f27Ms2Pf31f25-s4Pf30f22Ps8Mf24)>>SCALE)+
          (abs(s4Mf30f26Ms8Mf28-s6Mf31f25Ms2Mf29f27)>>SCALE);
  fft[11]=(abs(s1Mf27s3f31s5f25s7f29+s2Mf30Ps4f28s6f26Ps8f16)>>SCALE)+
          (abs(s1Pf29s3f25s5f31s7f27+s2Pf26Ps4f28s6f30Ms8f24)>>SCALE);
  fft[12]=(abs(s8Pf28f24f20f16+s4Pf31f29f27f25)>>SCALE)+
          (abs(s8Mf30f18f26f22-s4Mf31f29f27f25)>>SCALE);
  fft[13]=(abs(s1Mf29s3f25s5f31s7f27+s2Mf30Ms4f28s6f26Ms8f16)>>SCALE)+
          (abs(s1Pf27s3f31s5f25s7f29+s2Pf26Ms4f28s6f30Ps8f24)>>SCALE);
  fft[14]=(abs(s4Pf30f22Ms8Mf24-s6Pf31f25Ps2Pf29f27)>>SCALE)+
          (abs(s4Mf30f26Ps8Mf28-s6Mf29f27Ps2Mf31f25)>>SCALE);
  fft[15]=(abs(s2Mf26Ps4f28s6f30Ms8f16-s1Mf25s3f27s5f29s7f31)>>SCALE)+
          (abs(s2Pf30Ps4f28s6f26Ps8f24-s1Pf31s3f29s5f27s7f25)>>SCALE);
}

#include <bios.h>

/*------------------------------- Initialize ---------------------------------*/

void begin(void)
{
if (reset_dsp()!=0)
	{
	printf("Unable to reset SoundBlaster.\n\n");
    exit(1);
	}
}

/**********************decode DTMF tones******************************/

/*         return decoded keypress or 0  */

int tones()
	{
	int cmax=-1, rmax=-1;
	if ( col[0]-THRESHOLD > col[1] && col[0]-THRESHOLD > col[2] ) cmax = 0;
	if ( col[1]-THRESHOLD > col[0] && col[1]-THRESHOLD > col[2] ) cmax = 1;
	if ( col[2]-THRESHOLD > col[0] && col[2]-THRESHOLD > col[1] ) cmax = 2;

	if ( row[1]-THRESHOLD > row[3] && row[0] > row[2] ) rmax = 0;
	if ( row[1]-THRESHOLD > row[3] && row[2] > row[0] ) rmax = 1;
	if ( row[2]-THRESHOLD > row[0] && row[2]-THRESHOLD > row[1] && row[2]-THRESHOLD > row[3] ) rmax = 2;
	if ( row[3]-THRESHOLD > row[0] && row[3]-THRESHOLD > row[1] && row[3] > row[2] ) rmax = 3;
/*
	printf("\nCOL %d ROW %d ",cmax,rmax);
*/
	if ( cmax+1 && rmax+1 )
		return 1+3*rmax+cmax;
	else return 0;
	}

int decode(int tone)
{
static char key[12]={'1','2','3','4','5','6','7','8','9','*','0','#'};
static int atone=0, ctone=0, dtone=0, t;
static int wastone=0;

if ( !ctone && !dtone && tone == atone &&  tone )
	{
	t = tone-1;
	printf("%c",key[t]);
	buffer[bptr++] = key[t];
	wastone = 100;
	}
else
	{
	if ( !tone && !--wastone )
		{
		printf("\n");
		buffer[bptr++] = '\n';
		if (fptr)
			{
			long int ztime;
			time(&ztime);
			fputs(ctime(&ztime),fptr);
			fputs(buffer,fptr);
			}
		bptr = 0;
		buffer[0] = '\0';
		}
	}
dtone=ctone;
ctone=atone;
atone=tone;
}
/*---------------------------------- main ------------------------------------*/


void main(int argc, char *argv[])
{
static int sloop;
int i,j,key;
long count=0;
long int ztime,etime;

printf("\nDTMF 1.01 SoundBlaster decoder (c) 1993 Peter Jennings\n\n"
		 "DTMF  [filename]   optionally saves tones to a file\n\n"
		 "ESC   to exit\n"
		 "Space to check sample rate\n\n");
time(&ztime);
begin();
memset(buffer,0,1024);
if ( argc > 1 )
	{
	fptr = fopen(argv[1],"a");
	fputs("START AT: ",fptr);
	fputs(ctime(&ztime),fptr);
	fputs("\n",fptr);
	}
else
	fptr = 0;

while (1)
	{
	for ( i=0;i<4;i++)row[i]=0;
	for ( i=0;i<3;i++)col[i]=0;
	for (sloop=0 ; sloop < 3 ; sloop++)
		{
		FFT();
		for(j=0; j<3; j++) col[j] += fft[j+10];
		for(j=0; j<4; j++) row[j] += fft[j+5];
		}
/*
	printf("\n%3d %3d %3d    %3d %3d %3d %3d",col[0],col[1],col[2],row[0],row[1],row[2],row[3]);
*/
	decode(tones());
	if (bioskey(1))
		{
		if ( (key = getch()) == 0x1b ) break;
		if ( key == ' ' )
			{
			time(&etime);
			printf("\nSamples per second: %ld\n", count/(etime-ztime) );
			count = 0;
			time(&ztime);
			}
        }
	count++;
	}
if ( fptr )
	{
	fputs(buffer,fptr);
	fputs("\nSTOP AT: ",fptr);
	time(&ztime);
	fputs(ctime(&ztime),fptr);
	fputs("===================================\n",fptr);
	fclose(fptr);
	}
}
